<script lang="ts" setup>
import { ref } from 'vue';
import NavigationMobileMenu from './NavigationMobileMenu.vue';
import { Gitlab, ArrowRight, Search } from 'slippers-ui/icons';
import HamburgerIcon from '~/assets/icons/hamburger.vue';
import UserIcon from '~/assets/icons/user.vue';
import type { MainNavigation } from '@/types/navigation';

defineProps<{
  data: MainNavigation;
  freeTrialLink: string;
  hideSalesButton: boolean;
}>();

// refs
const isMenuOpen = ref(false);
const isSearchOpen = ref(false);

// methods
const toggleNavMenu = () => {
  isSearchOpen.value = false;
  isMenuOpen.value = !isMenuOpen.value;
};
const toggleSearch = () => {
  isSearchOpen.value = !isSearchOpen.value;
};
</script>

<template>
  <div>
    <NavigationSearch v-show="isSearchOpen" ref="slpSearch" v-bind="data.search" @close="toggleSearch" />
    <div class="be-nav-tablet">
      <SlpButton
        variant="icon"
        :href="data.logo.config.href"
        data-nav="logo"
        aria-label="Home"
        name="Home"
        :data-ga-name="data.logo.config.dataGaName"
        :data-ga-location="data.logo.config.dataGaLocation"
      >
        <SlpIcon :icon="Gitlab" size="lg" aria-id="tanukiHomeTablet" />
      </SlpButton>
      <div>
        <!-- Talk to an expert button for Tablets -->
        <SlpButton
          v-if="!hideSalesButton"
          :href="data.sales.config.href"
          variant="secondary"
          class="slp-mr-8"
          :data-ga-name="data.sales.config.dataGaName"
          :data-ga-location="data.sales.config.dataGaLocation"
          :data-nav="data.sales.config.dataGaName"
        >
          {{ data.sales.text }}
        </SlpButton>
        <SlpButton
          :href="freeTrialLink"
          variant="primary"
          :data-ga-name="data.freeTrial.config.dataGaName"
          :data-ga-location="data.freeTrial.config.dataGaLocation"
          :data-nav="data.freeTrial.config.dataGaName"
        >
          {{ data.freeTrial.text }}
        </SlpButton>
        <SlpButton
          variant="icon"
          :href="data.login.config.href"
          class="slp-ml-16"
          aria-label="Login"
          :data-ga-name="data.login.config.dataGaName"
          :data-ga-location="data.login.config.dataGaLocation"
          :data-nav="data.login.config.dataGaName"
        >
          <UserIcon slp-color="primary-200" />
        </SlpButton>
        <SlpButton
          variant="icon"
          class="slp-ml-16 search-icon"
          aria-label="search"
          data-nav="site search"
          @click="toggleSearch()"
        >
          <SlpIcon :icon="Search" size="sm" />
        </SlpButton>
        <SlpButton variant="icon" class="slp-ml-16" aria-label="Main menu" @click="toggleNavMenu()">
          <HamburgerIcon />
        </SlpButton>
      </div>
    </div>
    <div class="be-nav-phone">
      <SlpButton
        :href="freeTrialLink"
        variant="primary"
        class="navigation-top"
        :data-ga-name="data.freeTrial.config.dataGaName"
        :data-ga-location="data.freeTrial.config.dataGaLocation"
        :data-nav="data.freeTrial.config.dataGaName"
      >
        {{ data.freeTrial.text }}
        <SlpIcon :icon="ArrowRight" size="sm" class="be-nav-phone__icon slp-ml-8" />
      </SlpButton>
      <div class="navigation-bottom">
        <SlpButton
          variant="icon"
          aria-label="search"
          data-nav="site search"
          class="search-icon"
          @click="toggleSearch()"
        >
          <SlpIcon :icon="Search" size="sm" />
        </SlpButton>
        <SlpButton
          variant="icon"
          :href="data.logo.config.href"
          data-nav="logo"
          aria-label="Home"
          name="Home"
          :data-ga-name="data.logo.config.dataGaName"
          :data-ga-location="data.logo.config.dataGaLocation"
        >
          <SlpIcon :icon="Gitlab" size="md" aria-id="tanukiHomeMobile" />
        </SlpButton>
        <SlpButton variant="icon" class="slp-ml-16" aria-label="Main menu" @click="toggleNavMenu()">
          <HamburgerIcon />
        </SlpButton>
      </div>
    </div>
    <NavigationMobileMenu
      v-if="isMenuOpen"
      :navigation-data="data"
      :hide-sales-button="hideSalesButton"
      @on-close="toggleNavMenu()"
    />
  </div>
</template>

<style lang="scss" scoped>
.be-nav-tablet {
  display: flex;
  align-items: center;
  justify-content: space-between;
  padding: $spacing-16 $spacing-8;
  background-color: $color-surface-50;

  @media (max-width: $breakpoint-sm) {
    display: none;
  }

  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }
}

.be-nav-phone {
  background-color: $color-surface-50;

  @media (min-width: #{$breakpoint-sm + 1}) {
    display: none;
  }

  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  .navigation-top {
    width: 100%;
    border-radius: 0;
    justify-content: center;

    &:hover {
      svg {
        fill: #000000;
      }
    }
  }

  .navigation-bottom {
    padding: $spacing-16;
    display: flex;
    align-items: center;
    justify-content: space-between;

    .search-icon {
      -webkit-appearance: none;
      appearance: none;
      color: $color-surface-700 !important;

      svg path {
        fill: $color-surface-700 !important;
      }
    }
  }
  &__icon,
  &__icon * {
    color: #fff;
    fill: currentColor;
    .navigation-top:hover & {
      color: #000;
    }
  }
}
</style>
